//
//  NewSellerUserVC.swift
//  ICanRefer
//
//  Created by TalentMicro on 17/10/19.
//  Copyright © 2019 TalentMicro. All rights reserved.
//

import UIKit

protocol NewSellerUserVCDelegate: class {
    func didAddedUser()
}

class NewSellerUserVC: AppBaseViewController,CountryCodeSelectViewControllerDelegate {

    @IBOutlet weak var txtMobileISd: RCTextField!
    
    @IBOutlet weak var txtMobileNo: RCTextField!
    
    @IBOutlet weak var txtPhoneIsd: RCTextField!
    
    @IBOutlet weak var txtPhoneNo: RCTextField!
    
    @IBOutlet weak var txtFirstName: RCTextField!
    
    @IBOutlet weak var txtLastName: RCTextField!
    
    @IBOutlet weak var txtJobTitle: RCTextField!
    
    @IBOutlet weak var txtEmailId: RCTextField!
    
    @IBOutlet weak var txtViewNotes: NKTextView!
    
    @IBOutlet weak var lblUserId: NKLabel!
    
    @IBOutlet weak var collectionViewStatus: UICollectionView!
    
    @IBOutlet weak var viewUserId: RCView!
    
    @IBOutlet weak var viewResetPassword: RCView!
    
    @IBOutlet weak var heightViewUserId: NSLayoutConstraint!
    
    @IBOutlet weak var topSpaceTxtFirstname: NSLayoutConstraint!
    
    @IBOutlet weak var heightViewResetPassword: NSLayoutConstraint!
    
    @IBOutlet weak var topSpaceForBtnSubmit: NSLayoutConstraint!
    
    @IBOutlet weak var btnSubmit: NKButton!
    
    var sellerCode:Int = 0
    
    var sellerUserId:Int = 0
    
    var sellerUserDetails:SellerUserDetailModel?
    
    var selectedIndex:Int = 1
    
    var statusList:[SellerStatusModel]?
    
    var selectedCountryCode : CountryCodeModel?
    
    var activeTextField = UITextField()
    
    var isDetail:Bool = false
    
    weak var delegate:NewSellerUserVCDelegate?
    
    let btnName = UIButton()
    
    let firstAttributes: [NSAttributedString.Key: Any] = [
        .font: UIFont.fontForType(textType: 3),
        .foregroundColor: UIColor.darkGray]
    
    let secondAttributes: [NSAttributedString.Key: Any] = [
        .font: UIFont.fontForType(textType: 1),
        .foregroundColor: UIColor.black]
    
    let thirdAttributes: [NSAttributedString.Key: Any] = [
        .font: UIFont.fontForType(textType: 8),
        .foregroundColor: UIColor.darkGray]
    
    var isAdmin:Int?
          
    var isPartnerForCompany:Int?
    
    override func viewDidLoad() {
        super.viewDidLoad()

        navigationItem.title = "Seller".localized()
        
        btnName.setTitle("Submit-->", for: .normal)
        btnName.frame = CGRect(x: 0, y: 0, width: 30, height: 30)
        btnName.setTitleColor(UIColor.white, for: .normal)
        btnName.addTarget(self, action: #selector(callSubmit), for: .touchUpInside)
        
        let rightBarButton = UIBarButtonItem()
        rightBarButton.customView = btnName
        self.navigationItem.rightBarButtonItem = rightBarButton
        
        txtMobileISd.delegate = self
        txtPhoneIsd.delegate = self
        txtFirstName.delegate = self
        txtMobileNo.delegate = self
        
        if let currentCountry =  getLocalCountryCode(){
            selectedCountryCode = currentCountry
            
            txtMobileISd.text = currentCountry.dial_code
            txtPhoneIsd.text = currentCountry.dial_code
            
        }
        
    }
    
    override func viewWillAppear(_ animated: Bool) {
        
    if isDetail {
            viewUserId.alpha = 1
            
            heightViewUserId.constant = 40
            
            heightViewResetPassword.constant = 44
            
            viewResetPassword.alpha = 1
            
            topSpaceTxtFirstname.constant = 72
            
            topSpaceForBtnSubmit.constant = 60
            
            let firstText = NSMutableAttributedString(string:"\("User ID  ")",
                attributes: firstAttributes)
            
            let secondText = NSMutableAttributedString(string:"\(sellerUserId)",
                attributes: secondAttributes)
            
            let thirdText = NSMutableAttributedString(string:"\("  (Generated by software)")",
                attributes: thirdAttributes)
            
            let combination = NSMutableAttributedString()
            
            combination.append(firstText)
            combination.append(secondText)
            combination.append(thirdText)
            
            lblUserId.attributedText = combination
            
            btnName.setTitle("Update-->", for: .normal)
            
            btnSubmit.setTitle("Update", for: .normal)
        
            fetchUserDetails()
        
        btnName.alpha = 0
        btnSubmit.alpha = 0
            
        if isAdmin == 1 || isPartnerForCompany == 1 {
                                 
                 btnName.alpha = 1
                 btnSubmit.alpha = 1
                   
                }
        }
        
      else {
            
            viewUserId.alpha = 0
            
            heightViewUserId.constant = 0
            
            heightViewResetPassword.constant = 0
            
            viewResetPassword.alpha = 0
            
            topSpaceTxtFirstname.constant = 20
            
            topSpaceForBtnSubmit.constant = 20
            
            btnName.setTitle("Submit-->", for: .normal)
            
            btnSubmit.setTitle("Submit", for: .normal)
            
        }
        
    
    }
    
    func updateUI() {
        
        if sellerUserDetails != nil {
            
            txtFirstName.text = sellerUserDetails?.firstName ?? ""
            txtLastName.text = sellerUserDetails?.lastName ?? ""
            txtEmailId.text = sellerUserDetails?.emailId ?? ""
            txtPhoneNo.text = sellerUserDetails?.phoneNumber ?? ""
            txtPhoneIsd.text = sellerUserDetails?.phoneIsd ?? ""
            txtMobileISd.text = sellerUserDetails?.mobileIsd ?? ""
            txtMobileNo.text = sellerUserDetails?.mobileNumber ?? ""
            txtJobTitle.text = sellerUserDetails?.jobTitle ?? ""
            txtViewNotes.text = sellerUserDetails?.noteToReferralMember ?? ""
            selectedIndex = sellerUserDetails?.status ?? 0
        
            
            collectionViewStatus.reloadData()
        }
        
    }
    
    func openCountrySelector() {
        let storyBoard = UIStoryboard.init(name: CountryCodeSB, bundle: nil)
        let countrySelector:CountryCodeSelectViewController = storyBoard.instantiateViewController(withIdentifier: "CountryCodeSelectViewController") as! CountryCodeSelectViewController
        countrySelector.selectedCountryCode = selectedCountryCode
        countrySelector.delegate = self
        navigationController?.pushViewController(countrySelector, animated: true)
    }
    
    func didFinishSelectingCountryCode(selectedCountry: CountryCodeModel) {
        selectedCountryCode = selectedCountry
        
        if txtMobileISd == activeTextField {
            txtMobileISd.text = selectedCountry.dial_code
        }
        if txtMobileISd == activeTextField {
            txtPhoneIsd.text = selectedCountry.dial_code
        }
        
    }
    
    
    @IBAction func btnResetPasswordAction(_ sender: Any) {
        
        let storyBoard = UIStoryboard.init(name: UserSB, bundle: nil)
        let newProductPage:UserResetPasswordViewController = storyBoard.instantiateViewController(withIdentifier: "UserResetPasswordViewController") as! UserResetPasswordViewController
        newProductPage.sellerCode = sellerCode
        newProductPage.sellerUserId = sellerUserId
        navigationController?.pushViewController(newProductPage, animated: true)
        
    }
    @IBAction func btnSubmitAction(_ sender: Any) {
        
        callSubmit()
        
    }
    
    @objc func callSubmit(){
        
        if txtFirstName.text?.count ?? 0 <= 0 {
            
           txtFirstName.showError(message: "Required".localized())
            
            return
            
        }
        
       else if txtMobileNo.text?.count ?? 0 <= 0 {
            
            txtMobileNo.showError(message: "Required".localized())
            
        }
        
      else if txtMobileISd.text?.count ?? 0 <= 0 {
            
            txtMobileISd.showError(message: "Required".localized())
            
        }
        
        else{
            
            submitUserDetails()
            
        }
        
    }
    
    func fetchUserDetails() {
        
        let apiClient:APIClient = APIClient()
        //lblCartEmpty.text = "Loading...".localized()
        
        weak var weakSelf = self
        startAnimating()
        apiClient.GetRequest(urlString: ("\(ApiBaseUrl)icr/getSellerUserDetails?token=\(getCurrentUserToken())&lngId=\(Localize.currentLanguageID)&sellerCode=\(sellerCode)&sellerUserId=\(sellerUserId)"), params: nil, completionHandler:{response, jsonObj in
            
            var message:String = failedToConnectMessage.localized()
            if let serverMessage = jsonObj?.message(){
                message = (serverMessage.count>0) ? serverMessage : message
            }
            weakSelf?.stopAnimating()
            //weakSelf?.lblCartEmpty.text = ""
            if let response = response {
                if  weakSelf?.validateStatus(response: response) ?? false{
                    if let dataStr:String =  jsonObj?.dataString(){
                        if let dataObj:NSDictionary =  weakSelf?.decryptData(encryptedString: dataStr){
                            do {
                                let data = try JSONSerialization.data(withJSONObject: dataObj as Any, options: JSONSerialization.WritingOptions.prettyPrinted)
                                let decoder = JSONDecoder()
                                print(dataObj)
                                
                                let jsonResponse = try decoder.decode(SellerUserDetailApiModel.self, from: data)
                                
                               
                                if let apiResponse:SellerUserDetailModel = jsonResponse.sellerUserDetails {
                                    
                                    weakSelf?.sellerUserDetails = apiResponse
                                    
                                }
                               
                                weakSelf?.updateUI()
                                
                                return
                            } catch {
                                print(error)
                                message = failedToConnectMessage.localized()
                                
                            }
                        }
                    }
                }
            }
            
            weakSelf?.showErrorMessage(message: message)
            
        })
        
    }
   
    func submitUserDetails(){
         startAnimating()
        let params:NSDictionary = ["sellerCode": sellerCode,
                                   "sellerUserId":sellerUserId,
                                   "firstName":txtFirstName.text ?? "",
                                   "lastName":txtLastName.text ?? "",
                                   "jobTitle": txtJobTitle.text ?? "",
                                   "mobileIsd": txtMobileISd.text ?? "",
                                   "mobileNumber": txtMobileNo.text ?? "",
                                   "phoneIsd": txtPhoneIsd.text ?? "",
                                   "phoneNumber":txtPhoneNo.text ?? "",
                                   "noteToReferralMember":txtViewNotes.text ?? "",
                                   "status": selectedIndex
                                   ]
        let encryptedParams = ["data": encryptParams(params: params)]
        let apiClient:APIClient = APIClient()
        weak var weakSelf = self

        apiClient.PostRequest(urlString: ("\(ApiBaseUrl)icr/saveSellerUsers?token=\(getCurrentUserToken())&lngId=\(Localize.currentLanguageID)"), params: encryptedParams as NSDictionary, completionHandler:{response, jsonObj in
            
            var message:String = failedToConnectMessage.localized()
            if let serverMessage = jsonObj?.message(){
                message = (serverMessage.count>0) ? serverMessage : message
            }
             weakSelf?.stopAnimating()
            if let response = response {
                
                if  weakSelf?.validateStatus(response: response) ?? false {
                    if let dataStr:String =  jsonObj?.dataString(){
                        
                        if let dataObj:NSDictionary =  weakSelf?.decryptData(encryptedString: dataStr){
                            
                        do {
                            let data = try JSONSerialization.data(withJSONObject: dataObj as Any, options: JSONSerialization.WritingOptions.prettyPrinted)
                            //let decoder = JSONDecoder()
                            let decoder = JSONDecoder()
                            let dateFormat:DateFormatter = DateFormatter.init()
                            dateFormat.dateFormat = "yyyy-MM-dd HH:mm:ss"
                            //dateFormat.timeZone = TimeZone.init(secondsFromGMT: 0)
                            decoder.dateDecodingStrategy = .formatted(dateFormat)
                            
                            weakSelf?.delegate?.didAddedUser()
                            weakSelf?.navigationController?.popViewController(animated: true)
                            
                            return
                    
                            
                        } catch {
                            print(error)
                            message = failedToConnectMessage.localized()
                        }
                      }
                    }
                }
                 weakSelf?.showErrorMessage(message: message)
                weakSelf?.dismiss(animated: true, completion: nil)
                
            }
            
            //Show error
            //  weakSelf?.showErrorMessage(message: message)
            
        })
        
        
    }
    
    

}
extension NewSellerUserVC:UITextFieldDelegate{
    
    func textFieldShouldBeginEditing(_ textField: UITextField) -> Bool {
        if textField ==  txtPhoneIsd || textField == txtMobileISd {
            
            self.activeTextField = textField
            
            openCountrySelector()
            
            return false;
        }
        return true
    }
    
    func textField(_ textField: UITextField, shouldChangeCharactersIn range: NSRange, replacementString string: String) -> Bool {
        if let txtField:RCTextField = textField as? RCTextField{
            txtField.showError(message: "")
        }
        
        return true
    }
}

extension NewSellerUserVC:UICollectionViewDelegate,UICollectionViewDataSource,UICollectionViewDelegateFlowLayout{
    
    func collectionView(_ collectionView: UICollectionView, layout collectionViewLayout: UICollectionViewLayout, sizeForItemAt indexPath: IndexPath) -> CGSize {
        
        if collectionView == collectionViewStatus
            
        {
            return CGSize.init(width: collectionViewStatus.frame.width / 4, height: 40.0)
            
        }
        return CGSize.init()
    }
    
    func collectionView(_ collectionView: UICollectionView, numberOfItemsInSection section: Int) -> Int {
            
            if statusList?.count ?? 0 > 0 {
                
                return statusList?.count ?? 0
            }
        
        return 0
        
    }
    
    func collectionView(_ collectionView: UICollectionView, cellForItemAt indexPath: IndexPath) -> UICollectionViewCell {
            
            if let cell:StatusCell = collectionView.dequeueReusableCell(withReuseIdentifier: "StatusCell", for: indexPath) as? StatusCell {
                
                return getCellForStatus(cell: cell, indexPath: indexPath)
                
            }
        
        return UICollectionViewCell.init()
        
    }
    
    func collectionView(_ collectionView: UICollectionView, didSelectItemAt indexPath: IndexPath) {
        
        
            selectedIndex = indexPath.row
            
            collectionViewStatus.reloadData()
        
    }
    

    
    func getCellForStatus(cell:StatusCell,indexPath:IndexPath) -> StatusCell {
        
        if let model:SellerStatusModel = statusList?[indexPath.row] {
            
            cell.viewCellBackground.backgroundColor = .white
            cell.lblTitle.textColor = UIColor.getGradientColor(index: 0).first
            cell.lblTitle.text = model.statusTitle ?? ""
            
            if selectedIndex == indexPath.row {
                
                cell.viewCellBackground.backgroundColor = UIColor.getGradientColor(index: 0).first
                cell.lblTitle.textColor = .white
                
            }
            else{
                cell.viewCellBackground.backgroundColor = .white
                cell.lblTitle.textColor = UIColor.getGradientColor(index: 0).first
                
            }
            
        }
        return cell
    }
    
}
